/* -*- Mode: C; indent-tabs-mode: t; c-basic-offset: 8; tab-width: 8 -*- */
/***************************************************************************
 *            camel-imapx-conn-manager-friend.h
 *
 *  2012-01-20, 16:44:18
 *  Copyright 2012, Christian Hilberg
 *  <hilberg@unix-ag.org>
 ****************************************************************************/

/*
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Lesser General Public
 * License as published by the Free Software Foundation; either
 * version 2.1 of the License, or (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Lesser General Public License for more details.
 *
 * You should have received a copy of the GNU Lesser General Public
 * License along with main.c; if not, write to the Free Software
 * Foundation, Inc., 51 Franklin Street, Fifth Floor Boston, MA 02110-1301,  USA
 */

/* This file holds function prototypes needed by CamelIMAPXExtdConnManager,
 * but not exported by its parent class. In order not to mess with
 * upstream code, we (temporarily) declare the symbols here.
 * Once the *Extd* classes get merged into their upstream counterparts,
 * these can be removed
 */

/*----------------------------------------------------------------------------*/

#ifndef _CAMEL_IMAPX_CONN_MANAGER_FRIEND_H_
#define _CAMEL_IMAPX_CONN_MANAGER_FRIEND_H_

/*----------------------------------------------------------------------------*/

CamelIMAPXServer*
camel_imapx_conn_manager_find_connection_unlocked (CamelIMAPXConnManager *con_man,
                                                   const gchar *folder_name);

void
camel_imapx_conn_manager_conn_shutdown (CamelIMAPXServer *is,
                                        CamelIMAPXConnManager *con_man);

void
camel_imapx_conn_manager_conn_update_select (CamelIMAPXServer *is,
                                             const gchar *selected_folder,
                                             CamelIMAPXConnManager *con_man);

struct _ConnectionInfo*
camel_imapx_conn_manager_connection_info_new (CamelIMAPXServer *is);

void
camel_imapx_conn_manager_connection_info_insert_folder_name (struct _ConnectionInfo *cinfo,
                                                             const gchar *folder_name);

/*----------------------------------------------------------------------------*/

#endif /* _CAMEL_IMAPX_CONN_MANAGER_FRIEND_H_ */

/*----------------------------------------------------------------------------*/
